package uy.edu.fing.tse.jsf;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import uy.edu.fing.tse.central.business.BusinessLocal;
import uy.edu.fing.tse.central.business.common.Notifier;
import uy.edu.fing.tse.dto.Peripherical;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.AjaxBehaviorEvent;
import javax.faces.push.Push;
import javax.faces.push.PushContext;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@ViewScoped
@Named("faller")
public class RequestBean implements Serializable {

    private static final long serialVersionUID = 4465735311570405045L;


    private static final Logger LOG = LoggerFactory.getLogger(RequestBean.class);
    @EJB
    private BusinessLocal negocio;

    @Inject
    @Push
    PushContext channel;


    private Peripherical peri;
    private String name = "German";
    private String async;

    private List<String> mensaje = new ArrayList<>();

    @PostConstruct
    public void init() {
        LOG.info("Init");
        mensaje.add("INIT");
        Notifier.subscribe("test", this::pushToChannel);
    }

    public void pushed(AjaxBehaviorEvent e) throws AbortProcessingException {
        LOG.info("ajax pushed: " + e.toString());
        mensaje.add("ajaxListenerEvent is sent at: " + LocalDateTime.now());
    }

    public void commandScriptExecuted() {
        LOG.info("commandScriptExecuted pushed.");
        mensaje.add("commandScriptExecuted message is sent at: " + LocalDateTime.now());
    }

    public void pushToChannel(String s) {
        mensaje.add("Push: " + s);
        channel.send("updatemsg");
    }


    public void hacerAlgo() {
        LOG.info("hacerAlgo");
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAsync() {
        return async;
    }

    public void setAsync(String async) {
        this.async = async;
    }

    public Peripherical getPeri() {
        return peri;
    }

    public void setPeri(Peripherical peri) {
        this.peri = peri;
    }

    public List<String> getMensajes() {
        return mensaje;
    }

    public void setMensajes(List<String> mensaje) {
        this.mensaje = mensaje;
    }
}



